
#include <stddef.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <glib/gstdio.h>
#include <sys/types.h>
#include <dirent.h>

#include "red.xpm"
#include "blue.xpm"
#include "yellow.xpm"

GdkPixbuf *red_pixbuf;
GdkPixbuf *red_pixbuf2;
GtkWidget *red_image;
GdkPixbuf *blue_pixbuf;
GdkPixbuf *blue_pixbuf2;
GtkWidget *blue_image;
GdkPixbuf *yellow_pixbuf;
GdkPixbuf *yellow_pixbuf2;
GtkWidget *yellow_image;
GtkWidget *pref_image;

GtkStatusIcon *tray_icon;
int two_modes=0;
unsigned int interval = 5000; /*update interval in milliseconds*/
FILE *fp;
char inbuf1[200];
char governor[1000]="/etc/acpi/powermode";

gboolean Update(gpointer ptr);

gboolean Update(gpointer ptr) {
    int num;

        fp = fopen(governor,"r");
        fgets(inbuf1,sizeof inbuf1,fp);
        if (strncmp("performance",inbuf1,10) == 0)  gtk_status_icon_set_from_pixbuf(tray_icon,yellow_pixbuf);
        else if (strncmp("powersave",inbuf1,8) == 0)  gtk_status_icon_set_from_pixbuf(tray_icon,blue_pixbuf);
        else if (strncmp("turbo",inbuf1,4) == 0)  gtk_status_icon_set_from_pixbuf(tray_icon,red_pixbuf);
        fclose(fp);
	gtk_status_icon_set_tooltip(tray_icon, inbuf1);
    
}



void  view_popup_menu_turbo (GtkWidget *menuitem, gpointer userdata);
void  view_popup_menu_turbo (GtkWidget *menuitem, gpointer userdata)
  {
	system("/etc/acpi/turbo.sh&");
        gtk_status_icon_set_from_pixbuf(tray_icon,red_pixbuf);
  }
void  view_popup_menu_performance (GtkWidget *menuitem, gpointer userdata);
void  view_popup_menu_performance (GtkWidget *menuitem, gpointer userdata)
  {
	system("/etc/acpi/performance.sh&");
        gtk_status_icon_set_from_pixbuf(tray_icon,yellow_pixbuf);
  }
void  view_popup_menu_powersave (GtkWidget *menuitem, gpointer userdata);
void  view_popup_menu_powersave (GtkWidget *menuitem, gpointer userdata)
  {
	system("/etc/acpi/powersave.sh&");
        gtk_status_icon_set_from_pixbuf(tray_icon,blue_pixbuf);
  }
  
void  view_popup_menu_pref(GtkWidget *menuitem, gpointer userdata);
void  view_popup_menu_pref (GtkWidget *menuitem, gpointer userdata)
  {
		    system("laptop-tool&");
  }





void tray_icon_on_menu(GtkStatusIcon *status_icon, guint button, guint activate_time, gpointer user_data);
void tray_icon_on_menu(GtkStatusIcon *status_icon, guint button, guint activate_time, gpointer user_data)
{
        GtkWidget *menu, *menuitem;

        red_image=gtk_image_new_from_pixbuf(red_pixbuf2);
    	blue_image=gtk_image_new_from_pixbuf(blue_pixbuf2);
        yellow_image=gtk_image_new_from_pixbuf(yellow_pixbuf2);
        pref_image=gtk_image_new_from_stock(GTK_STOCK_PREFERENCES, GTK_ICON_SIZE_MENU);
       	menu = gtk_menu_new();

	if (two_modes!=1){
        	menuitem = gtk_image_menu_item_new_with_label("Turbo");
		gtk_image_menu_item_set_image(menuitem,red_image);
        	g_signal_connect(menuitem, "activate", (GCallback) view_popup_menu_turbo, status_icon);
        	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	}

        menuitem = gtk_image_menu_item_new_with_label("Performance");
	gtk_image_menu_item_set_image(menuitem,yellow_image);
        g_signal_connect(menuitem, "activate", (GCallback) view_popup_menu_performance, status_icon);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem) ;

        menuitem = gtk_image_menu_item_new_with_label("Powersave");
	gtk_image_menu_item_set_image(menuitem,blue_image);
        g_signal_connect(menuitem, "activate", (GCallback) view_popup_menu_powersave, status_icon);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
        
        menuitem = gtk_image_menu_item_new_with_label("Hardware Control");
	    gtk_image_menu_item_set_image(menuitem,pref_image);
        g_signal_connect(menuitem, "activate", (GCallback) view_popup_menu_pref, status_icon);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
        
        
        gtk_widget_show_all(menu);
        gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, status_icon, button,activate_time );
}

static GtkStatusIcon *create_tray_icon() {

    tray_icon = gtk_status_icon_new();
    g_signal_connect(G_OBJECT(tray_icon), "activate", G_CALLBACK(tray_icon_on_menu), NULL);
    g_signal_connect(G_OBJECT(tray_icon), "popup-menu", G_CALLBACK(tray_icon_on_menu), NULL);

    
    red_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)red_xpm);
    red_pixbuf2=gdk_pixbuf_new_from_xpm_data((const char**)red_xpm);
    blue_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)blue_xpm);
    blue_pixbuf2=gdk_pixbuf_new_from_xpm_data((const char**)blue_xpm);
    yellow_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)yellow_xpm);
    yellow_pixbuf2=gdk_pixbuf_new_from_xpm_data((const char**)yellow_xpm);

    gtk_status_icon_set_from_pixbuf(tray_icon,red_pixbuf);
    
    gtk_status_icon_set_visible(tray_icon, TRUE);

    return tray_icon;
}




int main(int argc, char **argv) {
	
   if((fp = fopen("/etc/acpi/powermode","r")) == NULL) exit(-1);
   fclose(fp);
    if((fp = fopen("/sys/devices/platform/eeepc/cpufv","r")) != NULL) { 
        fgets(inbuf1,sizeof inbuf1,fp);
        if (strncmp("0x2",inbuf1,3) == 0)  two_modes=1;
	fclose(fp);
    }


    GtkStatusIcon *tray_icon;

    gtk_init(&argc, &argv);
    tray_icon = create_tray_icon();
    
    gtk_timeout_add(interval, Update, NULL);
    Update(NULL);

    gtk_main();

    return 0;
}
